package com.application.basic;

import java.util.ArrayList;
import java.util.List;

import com.application.particles.flow.Streamlet;

import edu.unh.sdb.datasource.ISBounds;

import ar.ARNode;
import ar.ARNodeBlock;

public class ParticleARNode {
	// store the parent of all the leaves
	private List<Streamlet> visibleParticles;

	private List<Streamlet> invisibleParticles;
	
	private ArrayList<ARNode> arLeaves  ;
	
	private ARNode regionNode ;

	public ARNode getRegionNode() {
		return regionNode;
	}


	public void setRegionNode(ARNode regionNode) {
		this.regionNode = regionNode;
	}

	private  ISBounds nodeBounds;

	private ISBounds scaledBounds;
	
	private String id;

	public ParticleARNode[] children = new ParticleARNode[8];

	public ParticleARNode() {

		visibleParticles = new ArrayList<Streamlet>();
		invisibleParticles = new ArrayList<Streamlet>();
	}
	
	
	public String getId() {
		return id;
	}

	public void setId(String id) {
		this.id = id;
	}

	public List<Streamlet> getVisibleParticles() {
		return visibleParticles;
	}

	public void setVisibleParticles(List<Streamlet> visibleParticles) {
		this.visibleParticles = visibleParticles;
	}

	public List<Streamlet> getInvisibleParticles() {
		return invisibleParticles;
	}

	public void setInvisibleParticles(List<Streamlet> invisibleParticles) {
		this.invisibleParticles = invisibleParticles;
	}

	public void addVisibleParticle(Streamlet part) {
		this.visibleParticles.add(part);
	}

	public ISBounds getNodeBounds() {
		return nodeBounds;
	}

	public void setNodeBounds(ISBounds nodeBounds) {
		this.nodeBounds = nodeBounds;
	}

	public ISBounds getScaledBounds() {
		return scaledBounds;
	}

	public void setScaledBounds(ISBounds scaledBounds) {
		this.scaledBounds = scaledBounds;
	}

	public List<ARNode> getArLeaves() {
		return arLeaves;
	}

	public void setArLeaves(ArrayList<ARNode> arLeaves) {
		this.arLeaves = arLeaves;
	}
	
	
}
