package com.application.objects.threeD;

/**
 * Sphere.java -  class to create 3D sphere
 *  			- child class of Object3D 
 *  
 * @author Dupuis 
 * Edited by Abinaya Pitchai 
 */

import javax.media.opengl.GL2;

import com.jogamp.opengl.util.gl2.GLUT;

public class Sphere extends Object3D {
	private GL2 gl;
	private GLUT glut;

	public Sphere(GL2 g1, GLUT g2) {
		// default values
		xScale = yScale = zScale = 1.0f;
		xRot = yRot = zRot = 0.0f;
		xLoc = yLoc = 1.0f;
		zLoc = -100.0f;
		red = blue = 1.0f;
		green = 0.2f;
		sphere_radius = 0.5f;
		gl = g1;
		glut = g2;
		radians = 180.0f;

	}

	@Override
	public void redraw() {
		gl.glPushMatrix();
		gl.glColor3f(red, green, blue);
		gl.glTranslatef(xLoc, yLoc, zLoc);
		gl.glRotatef(radians, 1.0f, 0.0f, 0.0f);

		gl.glScalef(xScale + 1.0f, yScale + 3.0f, zScale);
		glut.glutSolidSphere(sphere_radius, 50, 50);
		gl.glPopMatrix();
	}

}
