package com.application.particles.flow;

import java.util.HashMap;
import javax.media.opengl.GL;
import javax.media.opengl.GL2;

import ar.ARStorageBlock;

import com.jogamp.opengl.util.gl2.GLUT;
import com.application.basic.Point3D;
import com.application.basic.Vector;
import com.application.objects.threeD.Cylinder;
import com.application.objects.threeD.Object3D;
import com.application.objects.threeD.Sphere;

import edu.unh.sdb.common.Datum;
import edu.unh.sdb.datasource.DataBlock;
import edu.unh.sdb.datasource.ISBounds;
import edu.unh.sdb.datasource.IntegerIndexSpaceID;

/**
 * Streamlet - class for creating 3D Blob.
 * 
 * @author AbinayaPitchai
 */

public class Streamlet {

	public float xval = 0.0f;
	public float yval = 0.0f;
	public float zval = 0.0f;
	public float initx;
	public float inity;
	public float initz;
	public boolean alive;
	public Point3D[] point3D = new Point3D[10];
	public int streamletObjectNum;
	public float color1[] = new float[3];
	public float color2[] = new float[3];
	public float color3[] = new float[3];
	public float sphereRadius[] = new float[10];
	public float rds1[] = new float[3];
	public float angle[] = new float[10];
	public Vector dn_rot[] = new Vector[10];

	public int recentARBlockIndex;
	public ISBounds recentARBounds;

	private int flag = 0;
	protected Object3D myObj1;
	protected Object3D myObj2;
	protected Object3D myObj3;
	public static Vector[] stPos = new Vector[10];
	private static GLUT glut = new GLUT();
	private float preX = 0.0f;
	private float preY = 0.0f;
	private float preZ = 0.0f;
	private Point3D delta;
	
	private int  myBlock ; 

	public int getMyBlock() {
		return myBlock;
	}

	public void setMyBlock(int myBlock) {
		this.myBlock = myBlock;
	}

	public Streamlet() {
		alive = false;
		rds1[0] = 80.0f;
		rds1[1] = 180.0f;
		rds1[2] = 0.0f;
		streamletObjectNum = 0;
		initializePoint3DArr();
		initializeSphereRadiusArr();
		initalizeRotationArr();
		initializeColorsArr();
		recentARBlockIndex = 0;
		recentARBounds = new ISBounds(new IntegerIndexSpaceID(0, 0, 0));
		delta = new Point3D(0.0f, 0.0f, 0.0f);

	}

	// ------------------------------------- Initialize
	// methods----------------------------------------------------------------------
	private void initializePoint3DArr() {
		point3D[0] = new Point3D(xval, yval, zval);
		point3D[1] = new Point3D(xval, yval, zval);
		point3D[2] = new Point3D(xval, yval, zval);
		point3D[3] = new Point3D(xval, yval, zval);
		point3D[4] = new Point3D(xval, yval, zval);
		point3D[5] = new Point3D(xval, yval, zval);
		point3D[6] = new Point3D(xval, yval, zval);
		point3D[7] = new Point3D(xval, yval, zval);
		point3D[8] = new Point3D(xval, yval, zval);
		point3D[9] = new Point3D(xval, yval, zval);
	}

	private void initializeSphereRadiusArr() {
		sphereRadius[0] = 5.2f;
		sphereRadius[1] = 5.25f;
		sphereRadius[2] = 5.3f;
		sphereRadius[3] = 5.35f;
		sphereRadius[4] = 5.4f;
		sphereRadius[5] = 5.45f;
		sphereRadius[6] = 5.5f;
		sphereRadius[7] = 5.55f;
		sphereRadius[8] = 5.6f;
		sphereRadius[9] = 5.65f;
	}

	private void initalizeRotationArr() {
		dn_rot[0] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[1] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[2] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[3] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[4] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[5] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[6] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[7] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[8] = new Vector(0.0f, 0.0f, 0.0f);
		dn_rot[9] = new Vector(0.0f, 0.0f, 0.0f);
	}

	private void initializeColorsArr() {
		color1[0] = 0.8f;
		color1[1] = 0.4f;
		color1[2] = 0.6f;
	}

	// -------------------------------------getter
	// methods-----------------------------------------------------------------------------
	public float getXParticle() {
		return xval;
	}

	public float getYParticle() {
		return yval;
	}

	public float getZParticle() {
		return zval;
	}

	// ------------------------------------- recent DataBlock
	// -------------------------------------------------------------------------

	public int getRecentBlock() {
		return recentARBlockIndex;
	}

	public void setRecentBlock(int recentBlockIndex) {
		this.recentARBlockIndex = recentBlockIndex;
	}

	// -------------------------------------- Draw Particles
	// ----------------------------------------------------------------------------
	public void drawParticles(GL2 gl, float vecScale,
			HashMap<String, Vector> vec, int streamletObjNo, int drawCt,
			boolean flow2d, boolean flow3d, boolean aStop) {
		int countOfObjsDrawn = 0, currObjNum;
		float dScale = 1.0f;
		float vScale = dScale * vecScale;
		float x1, y1, z1, dx = 0.0f, dy = 0.0f, dz = 0.0f;
		int xx1 = roundToNearestPosition(xval);
		int yy1 = roundToNearestPosition(yval);
		int zz1 = roundToNearestPosition(zval);

		// Creating JOGL 3D Objects
		// myObj1 = new Sphere(gl , glut ) ;
		myObj1 = new Cylinder(gl, glut);

		if ((xx1 >= ParticlesFlow.chunkSizeOfX)
				|| (yy1 >= ParticlesFlow.chunkSizeOfY)
				|| (zz1 >= ParticlesFlow.chunkSizeOfZ) || (xx1 < 0)
				|| (yy1 < 0) || (zz1 < 0)) {
			xx1 = 0;
			yy1 = 0;
			zz1 = 0;
		}
		x1 = xval * dScale;
		y1 = yval * dScale;
		z1 = zval * dScale;

		int zvalue2DOr3D = 0;
		if (flow2d == true) {
			zvalue2DOr3D = ParticlesFlow.slice;
		} else if (flow3d == true) {
			zvalue2DOr3D = zz1;
		}

		// Getting delta based on the position.
		// Multi Resolution selection
		if (ParticlesFlow.mrView.isSelected()) {
			delta.sx = (ParticlesFlow.getPosValueInDataSource(
					ParticlesFlow.block_DS1, xx1, yy1, zvalue2DOr3D) * -10); // *
																				// vScale
																				// ;
			delta.sy = (ParticlesFlow.getPosValueInDataSource(
					ParticlesFlow.block_DS2, xx1, yy1, zvalue2DOr3D) * -10); // *
																				// vScale
																				// ;
			delta.sz = (ParticlesFlow.getPosValueInDataSource(
					ParticlesFlow.block_DS3, xx1, yy1, zvalue2DOr3D) * -10); // *
																				// vScale
																				// ;
		}
		// Adaptive Resolution selection
		if (ParticlesFlow.arView.isSelected()) {
			IntegerIndexSpaceID id = new IntegerIndexSpaceID(zvalue2DOr3D, yy1,
					xx1);
			delta = ParticlesFlow.getPosValueInARDatasource(id, 0);
			delta.sx *= -10;
			delta.sy *= -10;
			delta.sz *= -10;
		}

		// Helix Flow
		// Datum datum = ParticlesFlow.getDatumByPosition(ParticlesFlow.dbHelix,
		// xx1, yy1, zvalue2DOr3D) ;
		// dx = datum.getFloat(0) * -10 ;
		// dy = datum.getFloat(1) * -10 ;
		// dz = datum.getFloat(2) * -10 ;

		if (ParticlesFlow.animating == true) {
			preX = (float) (x1 + (delta.sx));
			preY = (float) (y1 + (delta.sy));
			preZ = (float) (z1 + (delta.sz));
			xval = (float) preX;
			yval = (float) preY;
			zval = (float) preZ;
		}

		if ((streamletObjNo < 10) && ParticlesFlow.animating == true) {
			point3D[streamletObjNo].sx = preX;
			point3D[streamletObjNo].sy = preY;
			point3D[streamletObjNo].sz = preZ;

			// System.out.println("point3D[streamletObjNo] after  pre :" +
			// point3D[streamletObjNo].sx + " , " + point3D[streamletObjNo].sx +
			// " , " +point3D[streamletObjNo].sz);
			float nor_p1 = (float) Math.sqrt((x1 * x1) + (y1 * y1) + (z1 * z1));
			float nor_p2 = (float) Math.sqrt((preX * preX) + (preY * preY)
					+ (preZ * preZ));
			Vector p1 = new Vector((x1 / nor_p1), (y1 / nor_p1), (z1 / nor_p1));
			Vector p2 = new Vector((preX / nor_p2), (preY / nor_p2),
					(preZ / nor_p2));
			angle[streamletObjNo] = getAngle(p1, p2);
			dn_rot[streamletObjNo] = crossProduct(p1, p2);
		}

		// System.out.println("point3D[streamletObjNo] after  pre :" +
		// point3D[streamletObjNo].sx + " , " + point3D[streamletObjNo].sx +
		// " , " +point3D[streamletObjNo].sz);
		float nor_p1 = (float) Math.sqrt((x1 * x1) + (y1 * y1) + (z1 * z1));
		float nor_p2 = (float) Math.sqrt((preX * preX) + (preY * preY)
				+ (preZ * preZ));
		Vector p1 = new Vector((x1 / nor_p1), (y1 / nor_p1), (z1 / nor_p1));
		Vector p2 = new Vector((preX / nor_p2), (preY / nor_p2),
				(preZ / nor_p2));
		angle[streamletObjNo] = getAngle(p1, p2);
		dn_rot[streamletObjNo] = crossProduct(p1, p2);

		// modelling transformations :
	//	gl.glRotatef(300.0f, 0, 0, 1);
		// gl.glScalef(2 ,2, 2 ); // -- not displaying the particles if used.

		// getting scaling value
		int mul = ParticlesFlow.getScalingValue();

		if (((flow3d == true) || (flow2d == true)) && (flag >= 9)) {
			currObjNum = streamletObjNo + 1;
			while (currObjNum < drawCt) {
				myObj1.setColor(color1[0], color1[1], color1[2]);
				// System.out.println("New values :  " + currObjNum + " :::  " +
				// point3D[currObjNum].sx + ", " + point3D[currObjNum].sy + ", "
				// + point3D[currObjNum].sz);
				myObj1.setLocation(point3D[currObjNum].sx * mul,
						point3D[currObjNum].sy * mul, point3D[currObjNum].sz
								* mul);
				// myObj1.setParametersSphere(sphereRadius[countOfObjsDrawn],
				// angle[countOfObjsDrawn], dn_rot[countOfObjsDrawn]);
				myObj1.setParametersCylinder(ParticlesFlow.bRadius,
						ParticlesFlow.tRadius, ParticlesFlow.height,
						ParticlesFlow.stacks, ParticlesFlow.slices,
						angle[countOfObjsDrawn], dn_rot[countOfObjsDrawn]);
				myObj1.redraw();
				countOfObjsDrawn++;
				currObjNum++;
			}
			if (countOfObjsDrawn < drawCt) {
				if (streamletObjNo == 0) {
					currObjNum = 0;
					myObj1.setColor(color1[0], color1[1], color1[2]);
					// System.out.println("New values :  " + currObjNum +
					// " ::: " + point3D[currObjNum].sx + ", " +
					// point3D[currObjNum].sy + ", " + point3D[currObjNum].sz);
					myObj1.setLocation(point3D[currObjNum].sx * mul,
							point3D[currObjNum].sy * mul,
							point3D[currObjNum].sz * mul);
					// myObj1.setParametersSphere(sphereRadius[countOfObjsDrawn],
					// angle[countOfObjsDrawn], dn_rot[countOfObjsDrawn]);
					myObj1.setParametersCylinder(ParticlesFlow.bRadius,
							ParticlesFlow.tRadius, ParticlesFlow.height,
							ParticlesFlow.stacks, ParticlesFlow.slices,
							angle[countOfObjsDrawn], dn_rot[countOfObjsDrawn]);
					myObj1.redraw();
					countOfObjsDrawn++;
				} else {
					for (currObjNum = 0; currObjNum <= streamletObjNo; currObjNum++) {
						myObj1.setColor(color1[0], color1[1], color1[2]);
						// System.out.println("New values :   " + currObjNum +
						// " :::" + point3D[currObjNum].sx + ", " +
						// point3D[currObjNum].sy + ", " +
						// point3D[currObjNum].sz);
						myObj1.setLocation(point3D[currObjNum].sx * mul,
								point3D[currObjNum].sy * mul,
								point3D[currObjNum].sz * mul);
						// myObj1.setParametersSphere(sphereRadius[countOfObjsDrawn],
						// angle[countOfObjsDrawn], dn_rot[countOfObjsDrawn]);
						myObj1.setParametersCylinder(ParticlesFlow.bRadius,
								ParticlesFlow.tRadius, ParticlesFlow.height,
								ParticlesFlow.stacks, ParticlesFlow.slices,
								angle[countOfObjsDrawn],
								dn_rot[countOfObjsDrawn]);
						myObj1.redraw();
						countOfObjsDrawn++;
					}
				}
				countOfObjsDrawn = 0;
			}

		}
		flag++;
	}

	public float getAngle(Vector v1, Vector v2) {
		float vv1 = (float) Math.sqrt((v1.xval * v1.xval) + (v1.yval * v1.yval)
				+ (v1.zval * v1.zval));
		float vv2 = (float) Math.sqrt((v2.xval * v2.xval) + (v2.yval * v2.yval)
				+ (v2.zval * v2.zval));
		float var = dotProduct(v1, v2) / (vv1 * vv2);
		double val = Math.acos(var) * 180 / Math.PI; // + 90.0f ;

		return (float) val;
	}

	public Vector crossProduct(Vector v1, Vector v2) {

		float u = (v1.yval * v2.zval) - (v2.yval * v1.zval);
		float v = (v1.xval * v2.zval) - (v2.xval * v1.zval);
		float w = (v1.xval * v2.yval) - (v2.xval * v1.yval);
		// Vector ret;
		// if( v >= 0.0f){
		// ret = new Vector(u , v , w );
		// }else{
		// ret = new Vector(u , v , w );
		// }
		// return ret ;

		return new Vector(u, v, w);
	}

	public float dotProduct(Vector v1, Vector v2) {
		float u = (v2.xval * v1.xval);
		float v = (v2.yval * v1.yval);
		float w = (v2.zval * v1.zval);

		return (u + w + v);
	}

	private void draw2DLines(GL2 gl, float a1, float b1, float a2, float b2) {
		((GL2) gl).glColor3f(1.0f, 1.0f, 1.0f);
		((GL2) gl).glBegin(GL.GL_LINES);
		((GL2) gl).glVertex2f(a1, b1);
		((GL2) gl).glVertex2f(a2, b2);
		((GL2) gl).glEnd();
	}

	void cleanUp() {
		this.xval = this.yval = this.zval = 0.0f;
		this.initx = this.inity = this.initz = 0.0f;
		this.preX = this.preY = this.preZ = 0.0f;
	}

	/*
	 * Not used any where in code
	 */
	private Point3D getARPositionValuebyIndex(IntegerIndexSpaceID id) {

		ARStorageBlock arSBlk = ParticlesFlow.arStorage[0]
				.getArStorageBlockTable().get(recentARBlockIndex);
		if (arSBlk != null) {
			recentARBounds = arSBlk.getArBlockBounds();
		}

		boolean withinBlock = false;
		for (int d = 0; d < id.dim(); d++) {
			if (id.getCoord(d) >= recentARBounds.getLower(d)
					&& id.getCoord(d) <= recentARBounds.getUpper(d)) {
				withinBlock = true;
			} else {
				withinBlock = false;
				break;
			}
		}

		if (withinBlock) {
			int[] exacLoc = new int[3];
			exacLoc[0] = id.getCoord(0) - recentARBounds.getLower(0);
			exacLoc[1] = id.getCoord(1) - recentARBounds.getLower(1);
			exacLoc[2] = id.getCoord(2) - recentARBounds.getLower(2);

			IntegerIndexSpaceID offsetCalcuID = new IntegerIndexSpaceID(
					exacLoc[0], exacLoc[1], exacLoc[2]);

			float dx = ParticlesFlow.arStorage[0].getArStorageBlockTable()
					.get(recentARBlockIndex).getArDataBlock()
					.getFloat(offsetCalcuID, 0)
					* -10;
			float dy = ParticlesFlow.arStorage[1].getArStorageBlockTable()
					.get(recentARBlockIndex).getArDataBlock()
					.getFloat(offsetCalcuID, 0)
					* -10;
			float dz = ParticlesFlow.arStorage[2].getArStorageBlockTable()
					.get(recentARBlockIndex).getArDataBlock()
					.getFloat(offsetCalcuID, 0)
					* -10;

			return new Point3D(dx, dy, dz);
		} else {
			recentARBlockIndex = ParticlesFlow.getPosARBlockIndex(id, 0);
			getARPositionValuebyIndex(id);

		}

		return new Point3D(0.0f, 0.0f, 0.0f);
	}

	private int roundToNearestPosition(float val) {
		return Math.round(val);
	}

}
