//++++++++++++++++++++++++++ ARCellParser ++++++++++++++++++++++++++++
// Intended to allow parser to be invoked from any application, not
// just the "main" method of this file.
//
// Version 3. 11/01/01
//
// Generated from template using MakeParser program.
//------------------------- Edit history (since 10/21/05) -----------------------
// 10/21/05 rdb: Cleaned up unused variables and some reformatting.
//-------------------------------------------------------------------------------

package edu.unh.sdb.ARRSTreeBuilder;
import java.io.*;
import edu.unh.sdb.util.CommandProcessor.*;

//--------------------------ARCellParser class ----------------------
public class ARCellParser 
{
  // for running standalone, keep a reference to an instance available.
  private static ARCellParser theApp = null;

  // define the parser data member
  private CommandProcessor  parser  = null;

  // define a builder
  private ARRSBuilder       builder = null;
  private String            indexFile = "index.idx";
  
  //----------------- main -----------------------------------------
/*  public static void main( String argv[] ) throws IOException 
  {
    InputStream input = null;

    theApp = new ARCellParser();
    parseArgs( argv );
    System.out.println( "Using index file: " + theApp.indexFile );
    theApp.readAllCommands();
  }
*/

  //----------------- parseArgs( String[] ) -------------------------------
  public static void parseArgs( String argv[] ) 
  {
    // check for input file specification on command line
    if ( argv.length == 0 ) 
       theApp.setInput( System.in );
    else 
    {
       if ( !theApp.setInput( argv[0] ) )
       {
          System.err.println ("File can't be opened: " + argv[0] );
          System.err.println ("Using standard input");
          theApp.setInput( System.in );
       }
       if ( argv.length > 1 ) // data file specification
       {
          // the 2nd argument is a file name without extension
          theApp.setIndexFile( argv[ 1 ] + ".idx" );
       }
    }
  }
  //----------------- ARCellParser -----------------------------------------
  public ARCellParser(InputStreamReader inFile, ARRSBuilder builder)
  {
    this.builder = builder;
    this.parser = new CommandProcessor(inFile);
    // create the commands
    try
    {
       //%&%------- Insert defineCommand calls here -----------------------
       //  ntreeNode parent minx1 ... minxn maxx1 ... maxxn
       CommandAction nodeAction = new AddNodeAction( this.builder );
       parser.defineCommand( "n",     "iii*", nodeAction );
       parser.defineCommand( "ntree", "iii*", nodeAction );
       parser.defineCommand( "k",     "iii*", nodeAction );
       parser.defineCommand( "kd",    "iii*", nodeAction );
       //  nd-leaf parent minx1 ... minxn maxx1 ... maxxn s1 .. sn
       parser.defineCommand( "l",     "iii*", new AddLeafAction(this.builder) );
       //%&%---------- end defineCommand calls ----------------------------
    }
    catch ( CommandDefException cde )
    {
       System.err.println( cde.getMessage() );
       System.err.print( "*** Error in command specification " );
       if ( cde.command() != null )
          System.err.print( "for: " + cde.command() );
       if ( cde.parmSpec() != null )
          System.err.print( "with parameter specification: " + cde.parmSpec() );
       System.err.println();
    }
  }
  //----------------- ARCellParser( String ) ------------------------------
 /* public ARCellParser( String infile )
  {
     this();      // invoke default constructor
     if ( !setInput( infile ) )
     {
       // we could throw an IO Exception here ??
       System.err.println ("File can't be opened: " + infile );
       System.err.println ("Using standard input");
       theApp.setInput( System.in );
     }
  }
*/
  //++++++++++++++++++Accessor methods +++++++++++++++++++++++++++++++
  //----------------- boolean setInput( InputStream )  --------------------
  //  set the input file for parsing the language
  public void setInput( InputStream inFile ) 
  {
     this.parser.newReader( new InputStreamReader( inFile ));
  }
  //----------------- boolean setIndexFile( String )  --------------------
  //  set the input file for parsing the language
  public void setIndexFile( String inFile ) 
  {
     this.indexFile = inFile;
  }
  //----------------- String getIndexFile( String )  --------------------
  //  get the input file for parsing the language
  public String getIndexFile( ) 
  {
     return this.indexFile;
  }
  //----------------- boolean setInput( String )  --------------------
  //  set the input file for parsing the language
  public boolean setInput( String inFileName ) 
  {
     InputStreamReader inFile = null;
     try
     {
       inFile = new InputStreamReader( 
                      new FileInputStream ( inFileName ));
       this.parser.newReader( inFile );
     }
       catch ( IOException e )
       {
       }
     return inFile != null;
  }
  //++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++++
  //----------------- readAllCommands( )  ---------------------------
  // output the current value of the accumulator
  public void readAllCommands( ) throws IOException
  {
     this.parser.readAllCommands();
  }
  //----------------- nextCommand( )  ---------------------------
  // read and execute one command
  public boolean nextCommand( ) throws IOException
  {
     return this.parser.nextCommand();
  }
}
