/* 
  	BoundsException.java
  	Copyright 2000 University of New Hampshire
  	Durham, NH 03824
*/

package edu.unh.sdb.common;
//import java.io.*;

/** This exception is thrown whenever there is some kind of bounds violation.
 *     For example, if a DataSource is given an IndexSpaceID that is outside of its
 *     outer bounds, this exception could be thrown. Similarly, a call to the 
 *     setCoord() method of ISIterator might generate this exception. 
 *     
 *     In cases where it would be appropriate to throw either an 
 *     IllegalArgumentException or BoundsException, we should
 *     throw BoundsException, since it is more specific.
    
 */
public class BoundsException extends SDBException{

   private static final long serialVersionUID = 0; // for serialization inheritance
    /** Create an exception with the specified message.*/
	BoundsException(String message){
	
		super(message);
	}


} 