//
//  BytesOnlyRecordDescriptor.java
//  UDTServer
//
//  Created by Philip Rhodes on 1/5/08.
//  Copyright 2008 Philip J Rhodes. All rights reserved.
//
/** This class is used by servers to make PhysicalDatasources read data
 *  as bytes, regardless of the files actual data type. This prevents the
 *  server from performing type conversion that would be wasted effort, since
 *  the data must be sent as bytes over the network anyway.
 */
 
package edu.unh.sdb.common;

//import edu.unh.sdb.datasource.*;
import java.util.ArrayList;

//import java.util.ArrayList;
//import java.io.*;
 
 
public class BytesOnlyRecordDescriptor extends RecordDescriptor{

   public BytesOnlyRecordDescriptor(RecordDescriptor rd){
      
      super(rd.name, rd.types, rd.defs);
      
      int numByteFields = this.byteSize;
      
      this.defs = new AttributeDescriptor[numByteFields];
      
      for(int i=0; i< numByteFields; i++){
      
         this.defs[i] = new AttributeDescriptor(StorageType.Byte);
      }
      
      //this.defs = new AttributeDescriptor[]{new AttributeDescriptor(StorageType.Byte)};
      this.types = null;
      //this.byteOffsets = new int[]{0};
      
      
      this.typeCounters = new ArrayList<TypeCount>();
      //this.byteSize should be unchanged.
      //this.storageTypeCounts=new int[][] {{} ...
      //this.storageTypes = new int[]{StorageType.Byte};
      
      makeStorageTypeInfo();
      makeOffsets();
      
   }
   
//    /** Return the storage type of an attribute at the specified position.*/
//   public final int getStorageType(int index){
//
//      if(index > 1){
//         new SDBError(SDBError.Recoverable, "Invalid attribute index: " + index );
//         return 0;
//      } else {
//
//         return StorageType.Byte;
//      }
//   }
//
//    /** Return an array of storage types; there is one entry per attribute. 
//     */
//    public final int[] getStorageTypes()
//    {
//       return (int []) storageTypes.clone();
//    }

}
