
//
//  Configuration.java
//  Properties
//
//  Created by Philip Rhodes on Sun Dec 14 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
// ------------------- Revision history ---------------------------------
// 09/05/05 rdb: made file spec system independent using File.separatorChar
//-------------------------------------------------------------------------

package edu.unh.sdb.common;
import java.io.File;

public class Configuration {
    protected char slash = File.separatorChar; // OS independence: / or \
    protected String userHome =  System.getProperty( "user.home" ) + slash;
    //protected String configPath = userHome + "config" + File.separatorChar;
    //protected String dtdPath =  configPath + "dtd" + File.separatorChar;
    protected String configPath = null;
    protected String dtdPath = null;
    
    public Configuration()
    {
       String configDir = "config" + slash;
       String dtdDir    = "dtd" + slash;
       File dtdFile = new File( userHome + configDir + dtdDir );
       if ( dtdFile.isDirectory() )  // User overriding dtd files
       {
          // for now, user better override all .dtd files; really should
          // allow for individual overrides.
          configPath = userHome + configDir;
          dtdPath = configPath + dtdDir;
       }
    }
    
    public String getUserHome(){
    
        return this.userHome;
    }
    
    public String getConfigPath(){
    
        return this.configPath;
    }
    
    public String getDTDPath(){
    
        return this.dtdPath;
    }
}
