package edu.unh.sdb.common;

import javax.vecmath.Matrix4d;
import javax.vecmath.Vector3d;

/**
 * {@link EulerAngles} class for which heading rotates around Z axis, pitch
 * rotates around Y axis and bank rotates around X axes.
 */
public class EulerAnglesZYX extends EulerAngles
{

   public EulerAnglesZYX (double heading, double pitch, double bank)
   {
      super (heading, pitch, bank);
   }
   
   public EulerAnglesZYX (Vector3d v)
   {
      super (v);
   }

   public void rotateHeading (Matrix4d m)
   {
      m.rotZ (((double) getHeading () * Math.PI) / 180);
   }

   public void rotatePitch (Matrix4d m)
   {
      m.rotY (((double) getPitch ()) * Math.PI / 180);
   }

   public void rotateBank (Matrix4d m)
   {
      m.rotX (((double) getBank ()) * Math.PI / 180);
   }

   public Vector3d getInitialOrientation ()
   {
      return new Vector3d (1, 0, 0);
   }
   
   public void setFromMatrix (Matrix4d m)
   {
      throw new UnsupportedOperationException ("Not yet implemented");
   }
}
