//
//  RangedType.java
//  DS2Test
//
//  Created by Philip Rhodes on Sat Jan 19 2002.
//  Copyright (c) 2001 University of New Hampshire. All rights reserved.
//

package edu.unh.sdb.common;



public class RangedType extends UserType{
    
    //int storageType;
    double lo=Double.NEGATIVE_INFINITY,hi=Double.POSITIVE_INFINITY;

    public RangedType(String name,int storageType, double lo, double hi){

        super(name,storageType);

        if(storageType==StorageType.Record){
            new IllegalArgumentError(SDBError.Recoverable,
               "Storage Type for RangedType cannot be Record. (using double)");
            this.storageType=StorageType.Double;
        }

        
        if(hi <= lo){
            new IllegalArgumentError(SDBError.Recoverable,
               "Invalid range given for RangedType constructor. (will swap hi and lo bounds)");
            this.lo=hi;
            this.hi=lo;
        } else {
            this.lo=lo;
            this.hi=hi;
        }
    }


    
    public RangedType(String name,int storageType, long lo, long hi){

        super(name,storageType);
        
        if(hi <= lo){
            new IllegalArgumentError(SDBError.Recoverable,
                                     "Invalid range given for RangedType constructor. (will swap hi and lo bounds)");
            this.lo=hi;
            this.hi=lo;
        } else {
            this.lo=lo;
            this.hi=hi;
        }
     }

    

    public double getLowValue(){

        return lo;
    }

    public double getHighValue(){

        return hi;
    }

    public int getStorageType(){

        return storageType;
    }

    /** Returns true if the argument is structurally equivalent to this RangedType, false otherwise.*/
    public boolean equivalent(RangedType r){

        return (this.storageType == r.storageType) && (this.lo == r.lo) && (this.hi == r.hi);
    }
    
    
    public boolean equals(Object obj){
        RangedType r=(RangedType) obj;
        
        //return (this.storageType == r.storageType) && (this.lo == r.lo) && (this.hi == r.hi);
        return (super.equals(obj)) && (this.lo == r.lo) && (this.hi == r.hi);
    }

    /** Return a representation of this object as a nicely formatted String. */
    public String toString(){

        StringBuffer result=new StringBuffer(super.toString());
        
        result.append("[");
        result.append(this.lo);
        result.append(",");
        result.append(this.hi);
        result.append("] >>");

        return new String(result);
    }

}
