/*
 * XMLErrorHandler.java
 *
 * Author:  Gang Lu
 * University of New Hampshire
 * Durham, NH 03824
 * Created on July 18, 2003, 10:51 AM
 */

package edu.unh.sdb.common;

import org.xml.sax.SAXException;
import org.xml.sax.SAXParseException;
import org.xml.sax.ErrorHandler;

public class XMLErrorHandler implements ErrorHandler {
    
    
    public void warning(SAXParseException e) throws SAXException {
        
        show("Warning", e);
        
        // a new XMLError?
        //throw(e);
    }
    
    public void error(SAXParseException e) throws SAXException {
        
        show("Error", e);
       
        //throw(e);
    }
    
    public void fatalError(SAXParseException e) throws SAXException {
        show("Fatal Error", e);
        //throw(e);
    }
    
    private void show(String type, SAXParseException e){
        System.out.println(type + ": " + e.getMessage());
        System.out.println("Line " + e.getLineNumber() + " Column " + e.getColumnNumber());
        System.out.println("System ID: " + e.getSystemId());
    }
     
}
