/*
   programmer:     LI YE
*/
//-------------------- Edit history since 11/25/05 ------------------------
// 12/26/05 rdb: Did a bit of code cleanup. It's not very nice. It has special
//               code for whether iterating over a block or a ds. Shouldbe able
//               to be a handled by subclass methods.
// 11/25/05 rdb: Replace references to CopyLeaf methods with Leaf methods.
//-------------------------------------------------------------------------
/** 
 * The ARRSCellBlockIterator class provides an interface to iterate through 
 * all the leaves of an ARRS tree. each leaf of the tree contains a uniform 
 * cell block.
 */                                                                                
package edu.unh.sdb.datasource;

import java.util.*;
//import java.io.*;
                                                                                
import edu.unh.sdb.common.*;

public class ARRSCellBlockIterator extends CellBlockIterator {
    private CellIndexable arcellBlock;
    private CellIndexable leafcellDS;
    private ArrayList leafBlock;
    private int length;     //the number of the leaf blocks
    private int count;      //the number of the visited leaf blocks 

    /** construction with an uniform cell block */
    //public ARRSCellBlockIterator(ARRSCellBlock cblock)
    public ARRSCellBlockIterator(CellIndexable cblock)
    {
       super();
       this.arcellBlock = cblock;
    }

    /** Initialize this CellBlockIterator */
    public void init()
    {
       //rdb: simplified code somewhat
       if ( this.arcellBlock instanceof ARRSCellCopyDS )
       { 
          ARRSCellCopyDS ards = (ARRSCellCopyDS) this.arcellBlock; 
          ards.getARRSTree().clearLeafList();
          ards.getARRSTree().buildLeafList();
          this.leafBlock = ards.getARRSTree().getLeafList();
       }
       else if ( this.arcellBlock instanceof ARRSCellBlock )
       {
          ARRSCellBlock arblk = (ARRSCellBlock)this.arcellBlock;
          arblk.getARRSTree().clearLeafList();
          arblk.getARRSTree().buildLeafList();
          this.leafBlock = arblk.getARRSTree().getLeafList();
       }
       else
          new SDBError( SDBError.Fatal, "Unknown ARRS class: " 
                                        + this.arcellBlock.getClass().getName() );

       if ( !this.leafBlock.isEmpty() ) 
       {
          this.length = this.leafBlock.size();
          this.count = 0;
          //this.block = (URCellBlock)this.leafBlock.get(this.count);  
          this.leafcellDS = (URCellBlock)((ARRSLeafNode)this.leafBlock
                                                  .get(this.count)).getRegionData();  
          this.valid = true;
       }
    }

    /** Moving the CellBlockIterator to the next position. */
    public boolean next()
    {
       if (this.valid == false)
          return false;

       this.count++;
       if ( this.count < this.length ) 
       {
          this.leafcellDS = (URCellBlock)((ARRSLeafNode)this.leafBlock.get( this.count ))
                                              .getRegionData();  
          this.valid = true;
          return true;
       }
       else {
          this.valid = false;
          return false;
       }
    }    

    /** Get all the leaf blocks */
    public ArrayList getLeafBlockList()
    {
       return this.leafBlock;
    }

    /** Get a leaf cell block */
    public CellIndexable getLeafCellBlock()
    {
       return this.leafcellDS;
    }

    /** Return a String representing the object. */
    public String toString(){
        return this.toString("");
    }
     
    /** Return description of this ARRSCell */
    public String toString(String indent)
    {
       String indent2=indent+Globals.toStringIndent;
       StringBuffer result=new StringBuffer(indent
                                            +"{ ARRSCellBlockIterator:\n");
                     
       result.append(indent2+"valid = " + this.valid + "\n");
       if (this.leafcellDS instanceof URCellBlock)
          result.append(((URCellBlock)this.leafcellDS).toString(indent2)+"\n");
       if (this.leafcellDS instanceof RegCellDataSource)
          result.append(((RegCellDataSource)this.leafcellDS).toString(indent2)+"\n");
                     
       result.append(indent+"}");
       return new String(result);
    }
}

