/*
    ARRSClippedCopyLeafNode.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    Programmer: LI YE
*/
                                                                               
/**
 * The ARRSClippedCopyLeafNode class develop an ARRS leaf clipped node structure 
 * which contains a subblock info of ARRSCopyLeafNode.
 * It is extended from the ARRSCopyLeafNode class.
 */
//-------------------- Edit history as of 10/21/05 ------------------------------
// 12/10/05 rdb: Added copy constructors and copy method
// 11/24/05 rdb: Changed name from ARRSClippedLeafNode (may need a ClippedLeafRefNode)
// 10/31/05 rdb: Changed name from ARRSLeafClippedNode
//--------------------------------------------------------------------------------
                                                                               

package edu.unh.sdb.datasource;

//import java.io.*;
//import edu.unh.sdb.common.*;

public class ARRSClippedCopyLeafNode extends ARRSCopyLeafNode 
{
   private ISBounds subbounds;
      //store the bounds of a clipped block from a leaf node 
   
   /** Constructor without argument */
   public ARRSClippedCopyLeafNode()
   {
      super();
      this.subbounds = null;
   }
                                                                                
   /** Constructor takes a single ISbounds */
   public ARRSClippedCopyLeafNode( ISBounds bounds )
   {
      super(bounds);
      this.subbounds = null;
   }
                                                                                
   /** Constructor takes a ISbounds and a cell block */
   public ARRSClippedCopyLeafNode( ISBounds bounds, CellIndexable cblock )
   {
      super(bounds, cblock);
      this.subbounds = null;
   }
                                                                                
   /** Copy constructor  */
   public ARRSClippedCopyLeafNode( ARRSCopyLeafNode src )
   {
      super( src );
      this.subbounds = null;
   }
                                                                                
   /** Copy constructor with subbounds  */
   public ARRSClippedCopyLeafNode( ARRSClippedCopyLeafNode src )
   {
      super( src );
      this.subbounds = src.subbounds;
   }
   
   /** copy method creates references to all components, not copies.
    * 
    */
   public ARRSNode copy()
   {
      return new ARRSClippedCopyLeafNode( this );
   }
                                                                                
   /** Set a subbounds */
   public void setSubBounds( ISBounds subbounds )
   {
      this.subbounds = (ISBounds)subbounds.clone();
   }
 
   /** Get a subbounds */
   public ISBounds getSubBounds()
   {
      return this.subbounds;
   }

}
  
