package edu.unh.sdb.datasource;

import java.util.Map;

import org.testng.Assert;
import org.testng.annotations.AfterMethod;
import org.testng.annotations.BeforeMethod;
import org.testng.annotations.Test;

public class ARSparseDataSourceTest {
  
	private  ARSparseDataSourceOld ars ; 
	
	
	@BeforeMethod
	public void createARSparseDataSource(){
	
		String[] file_x = new String[2];
		file_x[0] = "TornadoData/Tornado-vx/tornado-vx.";
		file_x[1] = "xfdl";
		ars = new ARSparseDataSourceOld("TornadoData/Tornado-vx/tornado-sparse-vx.xfdl", file_x) ; 
		Assert.assertNotNull(ars); 
		
	}
	

	//@Test
	public void getSparsePartsMapTest(){
		int lower[] = { 0, 0, 18 } ; int[] upper = { 5, 5, 24} ;
		Assert.assertNotNull(ars.getSparsePartsMap(new ISBounds(lower, upper), 0));
	}
	
	@Test
	public void subblockTest(){
		int lower[] = { 0, 0, 18 } ; int[] upper = { 5, 5, 24} ;
		Map<ISBounds, DataBlock> partsMap = ars.subblock(new ISBounds(lower, upper), 0) ; 
		Assert.assertNotNull(partsMap);
	}
	
	
	
	@AfterMethod
	public void cleanUp(){
		ars = null ; 
	}
	
	
}
