/* 
	BlockListCacheDataSource.java
	Copyright 2000 University of New Hampshire
	Durham, NH 03824
*/


package edu.unh.sdb.datasource;
//import edu.unh.sdb.datasource;
import edu.unh.sdb.common.*;
//import java.io.*;


/** 
 */
public class BlockListCacheDataSource extends CacheDataSource{

        private ISBounds cacheBlockSize;
        private int numCacheBlocks;
	public BlockListCacheDataSource(String name, DataSource ds, ISBounds iterationSpace,
                                                 ISBounds cacheBlockSize, int numCacheBlocks )
        {
	     super(name, ds, iterationSpace);
             this.cacheBlockSize = cacheBlockSize;
             this.numCacheBlocks = numCacheBlocks;
	}

	/** Calls activate() for the underlying datasource, and creates the actual cache,
          * which allocates memory for the CacheBlock.
	  */	
	public void activate()
        {
	    super.activate();
            if( this.theSource instanceof PhysicalDataSource)
                 this.theCache=new BlockListCache( (PhysicalDataSource)this.theSource, 
                                              this.numCacheBlocks, this.cacheBlockSize);
            else
                new InternalFaultError(SDBError.Recoverable,
                            "BlockListCacheDataSource only support PhysicalDataSource");
         }
       public void setIterator(RandomBlockIterator iter)
       {
            ( (BlockListCache)this.theCache).setIterator(iter);
       }
}
