/*
    CellBlock.java
    Copyright 2004 University of New Hampshire
    Durham, NH 03824
    Programmer: LI YE
*/
                                                                                
/**
 * The CellBlock class provides an interface to access blocks of cell data
 * in a cell space.
 */
                                                                                
package edu.unh.sdb.datasource;
                                                                                
import edu.unh.sdb.common.*;
//import java.io.*;

public abstract class CellBlock extends DataBlock {
                                                                                
    /** Construct a CellBlock without arguments */
    public CellBlock()
    {
       super();
    }

    /** Construct a CellBlock with the given bounds, axis axisOrdering and 
      * RecordDescriptor. The bounds will be moved to the origin.
      */
    public CellBlock(ISBounds isb, AxisOrdering ordering,
                     RecordDescriptor recordDesc)
    { 
       super(isb, recordDesc, ordering);
    }
                                                                                
    /** Construct a CellBlock with the given bounds and number of attributes*/
    public CellBlock(ISBounds isb, RecordDescriptor recordDesc)
    {
       super(isb, recordDesc);
    }
                                                                                
    /** Construct a CellBlock with a given point DataBlock */
    public CellBlock(DataBlock b)
    {
       super(b);
    }
}
                                                                                
                                                                                
