//
//  CellBoundsIterator.java
//  CorrectnessTest
//
//  Created by Philip Rhodes on Tue Dec 23 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
//


package edu.unh.sdb.datasource;
//import java.io.*;
//import edu.unh.sdb.common.*;


/** CellBoundsIterator creates ISBounds with length 2 in all dimensions, and an overlap of -1.
  * That is, for a given index space, it returns all the cells of the index space in turn.
  */
public class CellBoundsIterator extends ISBoundsIterator {


   private static final long serialVersionUID = 0; // for serialization inheritance
    public CellBoundsIterator(ISBounds space){
    
        super(space.dim());
        
        int i, d = space.dim();
        
        this.ordering = new AxisOrdering(d);
		
        int [] shape = new int[d];
        int [] gaps  = new int[d];
        
        for(i=0; i<d; i++){
        
            shape[i] = 2;
            gaps[i] = -1;
        }
        
		setupAndCheck(shape, gaps);    
		        
        this.init(space);

    }

    public CellBoundsIterator(ISBounds space, AxisOrdering ordering){
    
        super(space.dim());
        
        int i, d = space.dim();
        
        this.ordering = ordering;
		
        int [] shape = new int[d];
        int [] gaps  = new int[d];
        
        for(i=0; i<d; i++){
        
            shape[i] = 2;
            gaps[i] = -1;
        }
        
		setupAndCheck(shape, gaps);    
		        
        this.init(space);

    }




    /** this is a help fuction for next() function, which is to set a 
     *  specified value to the specified axis if the value is in bounds 
     */
    protected boolean incrementAxis(int axisNumber){

		if( this.upper[axisNumber] >= this.ubounds[axisNumber]){
        
			return false;
			
		} else {
		
            this.lower[axisNumber] += this.steps[axisNumber];
			this.upper[axisNumber] += this.steps[axisNumber];

            // Is this necessary? Let's say no and see what happens.
			//this.lower[axisNumber] = ( this.lower[axisNumber] >= this.lbounds[axisNumber]) ? this.lower[axisNumber] : this.lbounds[axisNumber];
			this.upper[axisNumber] = ( this.upper[axisNumber] <= this.ubounds[axisNumber]) ? this.upper[axisNumber] : this.ubounds[axisNumber];
			
			
			return true;
		}
	
    }

}
