package edu.unh.sdb.datasource;
/**
 * 
 * @author AbinayaPitchai
 * since 04.18.14
 *
 */
public  class ConversionUtilities {

	/**
	 * stringToInt utility
	 * @param istr
	 * @return
	 */
	public static int stringToInteger( String istr ){
	   istr = istr.trim();
	   try {
	         return Integer.parseInt( istr );
	      }
	      catch (NumberFormatException nfe ) {
	         System.err.println( "Internal error: SparseDataSource.strToInt. "
	                             + nfe.getMessage() );
	      }
	      return -1;
	   }
	 
	/**
	 *  stringToIntArray utility 
	 * @param istr
	 * @return
	 */
	 public static int[] stringToIntArray( String istr ){
	     
		 String[] values = istr.split( "," );
	     int[] ivals = new int[ values.length ];
	      for ( int i= 0; i < values.length; i++ ){
	         ivals[ i ] = stringToInteger( values[ i ] );
	      }
	      return ivals;
	   }
	
	 
		/**
		 *  stringToIntArray utility 
		 * @param istr
		 * @return
		 */
		 public static Integer[] stringToIntegerArray( String istr ){
		     
			 String[] values = istr.split( "," );
		     Integer[] ivals = new Integer[ values.length ];
		      for ( int i= 0; i < values.length; i++ ){
		         ivals[ i ] = stringToInteger( values[ i ] );
		      }
		      return ivals;
		   } 
	/** arrayToString utility 
	 * @param arr
	 * @return
	 */
	 public static String arrayToString( int[] arr ){
	     
		if ( arr == null )
	         return "";
	    StringBuilder sb = new StringBuilder();
	    sb.append( "(" );
	    for (int i = 0; i < arr.length; i++){
	         sb.append( arr[i] );
	         sb.append( "," );
	      }
	    sb.setCharAt( sb.length() - 1, ')' );
	    return sb.toString();
	   } 
	 
	 
		/**
		 * stringToLong utility
		 * @param istr
		 * @return
		 */
		public static Long stringToLong( String istr ){
		   istr = istr.trim();
		   try {
		         return Long.parseLong( istr );
		      }
		      catch (NumberFormatException nfe ) {
		         System.err.println( "Internal error: SparseDataSource.strToInt. "
		                             + nfe.getMessage() );
		      }
		      return (long) -1;
		   }

}
