//
//  DSStencil.java
//  StencilTest
//
//  Created by Philip Rhodes on Sat Jan 17 2004.
//  Copyright (c) 2004 University of New Hampshire. All rights reserved.
//


package edu.unh.sdb.datasource;

//import java.io.*;
//import edu.unh.sdb.common.*;

public abstract class DSStencil {

   protected ISBounds space;
   protected int dimensionality;

   public DSStencil(ISBounds space){

     this.space = space.copy();
     
     this.dimensionality = this.space.dim();
   }

   /**added by Sridhar
    */
   public ISBounds getSpaceBounds()
   {
	   return this.space;
   }

   /** Set the stencil element containing the id to "active". If it is already
     * active, then the method returns false. Returns true otherwise.
     */
   public abstract boolean set(IndexSpaceID id);


   /** Set the stencil element with index corresponding to id to "active.  id 
     * should already have been mapped to the partitioning space. If it is already
     * active, then the method returns false. Returns true otherwise.
     */
   public abstract boolean setElement(IndexSpaceID id);




   /** Return true if the given id maps to an active stencil element, false otherwise.*/
   public abstract boolean get(IndexSpaceID id);

   /** Return a new ISBounds with shape equal to the indexed stencil element. */
   public ISBounds getIndexedBounds(int index)
   {
      return this.getIndexedBounds(new ISBounds(this.dimensionality), index);
   }

   /** sets the argument ISBounds to the bounds of the stencil element stored in this stencil
   *  list
   */
   public abstract ISBounds getIndexedBounds( ISBounds stencilBounds, int index);

   /** return number of elements contained by this stencil
   */
   public abstract int size();

   /** Return the dimensionality of the stencil domain. */
   public final int dim(){

      return this.dimensionality;
   }



}
