//
//  DataBlockCollection.java
//  StencilTest
//
//  Created by Philip Rhodes on 6/2/06.
//  Copyright 2006 Philip J Rhodes. All rights reserved.
//
//--------------------- edit history ------------------------------
// 06/05/08 rdb: makde ArrayList generic


package edu.unh.sdb.datasource;

import edu.unh.sdb.common.*;
import java.util.*;

/** Represents a list of DataBlocks. Currently, all blocks must have
 *  the same RecordDescriptor.
 */
public class DataBlockCollection {

   protected ArrayList<DataBlock> blockList;
   protected RecordDescriptor recordDescriptor;
   

   public DataBlockCollection(int size, RecordDescriptor recordDescriptor){
   
      this.blockList = new ArrayList<DataBlock>(size);
      this.recordDescriptor = recordDescriptor;
   }
   
   
   public void add(DataBlock block){
   
      this.blockList.add(block);
   }
   
   
   public DataBlock get(int i){
   
      return this.blockList.get(i);
   }
   
   public int size(){
   
      return this.blockList.size();
   }
   
   public void clear(){
   
      this.blockList.clear();
   }
   
   
   public RecordDescriptor getRecordDescriptor(){
   
      return this.recordDescriptor;
   }
   
   
   public int getStorageType(){
   
      return this.recordDescriptor.getStorageType();
   }

}
