/* 
    FileError.java
    Copyright 2000 University of New Hampshire
    Durham, NH 03824
*/
//---------------------- Edit history as of 11/24/05 ------------------------------
// 11/24/05 rdb: revised (and simplified) to use new SDBError.logError 
//---------------------------------------------------------------------------------

package edu.unh.sdb.datasource;

import edu.unh.sdb.common.*;
//import java.io.*;

/** This error is used when a file cannot be opened, read, etc.
       
    Creating an error will cause the message argument to be logged, and
    an exception to be raised, if appropriate. This behavior is governed
    by the error level given to the constructor, and by the error reporting
    level maintained in the SDBError class. 
    
    Invoking the constructor is sufficient to log the error. There is no
    need to save a reference to the error object.
    
 */

public class FileError extends SDBError
{
    /** Create an error with the specified error level and message.
        The error level can be either SDBError.Fatal or 
        SDBError.Recoverable.
    */
    
    public FileError( int errorLevel, String message )
    {
        super( errorLevel, new FileException( message ) );
    }  
} 
