//
//  ForeignReferenceDataSource.java
//  DS2Test
//
//  Created by Philip Rhodes on Fri Jul 26 2002.
//  Copyright (c) 2001 University of New Hampshire. All rights reserved.
//
/*------------------ Edit history as of 01/30/05 ------------------------
 * 01/30/05 rdb: deleted datum methods that return Datum and 
 *                       subblock methods that return DataBlock.
 *                 parent classes implement them ok.
 */
 
package edu.unh.sdb.datasource;
 
 
import edu.unh.sdb.common.*;
 
public class ForeignReferenceDataSource extends DataSource{
 
    protected String dbName;
    protected DataSource referent;
 
 
    public ForeignReferenceDataSource(String name, String dbName, DataSource referent){
 
        super(referent);
        
        this.name = name;
        this.dbName = dbName;
    }
 

    public String getName(){
    	return name;
    }


    public String getDBName(){
         return dbName;
    }
  

    public void activate(){
 
        referent.activate();
    }


 
 	/** The DataSource will release any resources used during the 
		readling or processing of data.*/    
    public void deactivate(){
	
		referent.deactivate();
	}
	 
    /** Return by reference the Datum corresponding to the given
     *  IndexSpaceID.
     */
    public void datum(Datum dtm, IndexSpaceID did){
 
        referent.datum(dtm,did);
    }
 
 
    /** Get the Datum and fill its values in the passed Datum at positions
     *  specified by the corresponding FieldIDMapper.
     */                    

    public void datum(Datum dtm, IndexSpaceID did, FieldIDMapper mp){
 
        referent.datum(dtm,did,mp);
    }
 
 
    /** Get the Datum and fill its values in the passed Datum at positions
     *  specified by the corresponding RecordSpec.
     */
    public void datum(Datum dtm, IndexSpaceID did, RecordSpec recSpec){
 
        referent.datum(dtm,did,recSpec);
    }
 
    public void subblock(DataBlock theBlock, ISBounds dstBounds, ISBounds srcBounds){
 
        referent.subblock(theBlock,dstBounds,srcBounds);
    }            

    public void subblock(DataBlock theBlock, ISBounds dstBounds, ISBounds srcBounds, FieldIDMapper mp){
 
        referent.subblock(theBlock,dstBounds,srcBounds,mp);
    }
  
    public void subblock(DataBlock theBlock, ISBounds dstBounds, ISBounds srcBounds, RecordSpec spec){
 
        subblock(theBlock,dstBounds,srcBounds,spec);
    }
 
 
}                   
 
