package edu.unh.sdb.datasource;


import edu.unh.sdb.datasource.ConversionUtilities;

/**
 *  A SparseBlock class.
 *  
 * @author AbinayaPitchai
 * since 04.17.14
 *
 */
public class SparseBlockInfo {

	private int sparseBlockId;
	
	private Integer[] size;
	
	private Integer[] startPosition;
	
	private int originalBlockId;
	
	private long seekAddress;

	public SparseBlockInfo(String sparseData){
		parseSparseBlockData(sparseData);
	}
	
	public int getSparseBlockId() {
		return sparseBlockId;
	}

	public void setSparseBlockId(int sparseBlockId) {
		this.sparseBlockId = sparseBlockId;
	}

	public Integer[] getSize() {
		return size;
	}

	public void setSize(Integer[] size) {
		this.size = size;
	}

	public Integer[] getStartPosition() {
		return startPosition;
	}

	public void setStartPosition(Integer[] startPosition) {
		this.startPosition = startPosition;
	}

	public int getOriginalBlockId() {
		return originalBlockId;
	}

	public void setOriginalBlockId(int originalBlockId) {
		this.originalBlockId = originalBlockId;
	}
	
	public long getSeekAddress() {
		return seekAddress;
	}

	public void setSeekAddress(long seekAddress) {
		this.seekAddress = seekAddress;
	}
	
	

	private void parseSparseBlockData(String sparseDataStr){
		
		// verify which is the sparse Id and original id
		int at = sparseDataStr.indexOf( "@" );
		setOriginalBlockId(ConversionUtilities.stringToInteger( sparseDataStr.substring( 0, at )));
		      
		int lparen = sparseDataStr.indexOf( "(" );
		int rparen = sparseDataStr.indexOf( ")" );
		setStartPosition(ConversionUtilities.stringToIntegerArray( sparseDataStr.substring( lparen+1, rparen )));
		      
		int eq = sparseDataStr.indexOf( "=" );     
		if ( eq >= 0 ){
		      lparen = sparseDataStr.indexOf( "(", eq ); // get next parens
		      rparen = sparseDataStr.indexOf( ")", eq );
		      setSize(ConversionUtilities.stringToIntegerArray( sparseDataStr.substring( lparen+1, rparen )));
		}
		      
		int arrow = sparseDataStr.indexOf( "->" );
		int hash = sparseDataStr.indexOf( "#" );
		String sub = sparseDataStr.substring( arrow + 2, hash -1 );
		setSparseBlockId(ConversionUtilities.stringToInteger( sparseDataStr.substring( arrow + 2, hash)));
		
		
		setSeekAddress(ConversionUtilities.stringToLong( sparseDataStr.substring( hash + 1 ))); 
		
	}
	
}
