/*
   programmer:     LI YE
*/

package edu.unh.sdb.datasource;

//import java.util.*;
//import java.io.*;
                                                                                
//import edu.unh.sdb.common.*;

public class URCellBlockIterator extends CellBlockIterator {
    private CellIndexable cellindexable; 
    private URCellBlock block;
    private ISBounds resolution;
    private int[] shapes;
    private int[] gaps;
    private ISBoundsIterator iter;
    
    /** construction with a cell block */
    public URCellBlockIterator(CellIndexable indexable, ISBounds resolution, 
                               int[] shapes, int[] gaps)
    {
       super();
       this.cellindexable = indexable; 
       this.resolution = (ISBounds)resolution.clone();
       this.shapes = shapes.clone();
       this.gaps = gaps.clone();
       this.iter = new ISBoundsIterator(this.resolution,this.shapes,this.gaps);
    }

    /** Initialize this URCellBlockIterator */
    public void init()
    {
       this.iter.init();
	   this.block = new URCellBlock(this.iter, this.cellindexable.getRecordDescriptor());
       if (this.iter.valid()) {
          this.valid = true;
          this.cellindexable.urCellBlock(this.block,this.iter,this.resolution); 
       }
    }

    /** Moving the CellBlockIterator to the next position. */
    public boolean next()
    {
       if (this.valid == false)
          return false;
       
       this.iter.next();
       if (this.iter.valid()) {
          this.valid = true;
          this.cellindexable.urCellBlock(this.block,this.iter,this.resolution);
          return true;
       }
       else {
          this.valid = false;
          return false;
       }
    }    

    /** get a cell block */
    public DataBlock getDataBlock()
    {
       return this.block;
    }


    /** Return description of this ARRSCell */
    public String toString(String indent){
       return null;
    }

}

