//
//  CellID.java
//  Unstructured
//
//  Created by Philip Rhodes on Mon Aug 11 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
//
//--------------------------------------------------------------------------
//Edit history (since 01/03/05
//   01/03/05 rdb Changed asDatum to return IntDatum instead of FloatDatum.
//
//--------------------------------------------------------------------------

package edu.unh.sdb.lattice;

import edu.unh.sdb.datasource.*;
import edu.unh.sdb.common.*;

public class CellID {
	
	IndexSpaceID partitionID;
	int index;

	public CellID(IndexSpaceID partitionID, int index){
	
		this.partitionID=partitionID;
		this.index=index;
	}


	public CellID(Datum d, int dim){
	
		int i;
		int[] coords=new int[dim];
		
		for(i=0; i<dim; i++){
		
			coords[i]=(int) d.getFloat(i);
		}
		
		this.partitionID=new IntegerIndexSpaceID(coords);
		this.index=(int) d.getFloat(i);
	}	


	void assign(IndexSpaceID partitionID, int index){
	
		this.partitionID=partitionID;
		this.index=index;
	}


	public IndexSpaceID getPartitionID(){
	
		return this.partitionID;
	}
	
	
	public void setPartitionID(IndexSpaceID partitionID){
	
		this.partitionID=partitionID;
	}
	
	
	
	public int getIndex(){
	
		return this.index;
	}


	public void setIndex(int index){
	
		this.index=index;
	}
	
	public void incrementIndex(){
		
		this.index++;
	}
	
	public IntDatum asDatum(){   //rdb: was FloatDatum 
	
		int  d=this.partitionID.dim();
		int [] vals=new int[d+1];
		
		this.partitionID.getCoords(vals);
		vals[d]=this.index;
		
		return new IntDatum(vals);   //rdb: was FloatDatum
	}



    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }    
    
	
	
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){

        StringBuffer result=new StringBuffer(indent+"CellID: partitionID=");
		
		result.append(this.partitionID);
		result.append(" index=");
		result.append(this.index);
		
        return new String(result);
    }
	
}
