//
//  FileCellGroup.java
//  Unstructured
//
//  Created by Philip Rhodes on Thu Aug 28 2003.
//  Copyright (c) 2003 __MyCompanyName__. All rights reserved.
//

package edu.unh.sdb.lattice;

import edu.unh.sdb.common.*;
//import java.io.*;


public abstract class FileCellGroup extends CellGroup{

    protected boolean inMemory=false;
	protected boolean backedByFile=false;
	
	protected String vInfoFdlName;
    protected String vIndexFdlName;
	
	protected RecordSpec dataRS;
	protected RecordSpec coordsRS;
	protected RecordSpec vIndicesRS;
	
	int numAttributes;


	FileCellGroup(GBounds bounds, String vIndexFdlName, RecordSpec vIndicesRS, String vInfoFdlName, RecordSpec coordsRS, RecordSpec dataRS){
	
		super(bounds);
		
		this.vIndexFdlName 	= new String(vIndexFdlName);
		this.vInfoFdlName 	= new String(vInfoFdlName);
		
		this.dataRS=dataRS;
		this.coordsRS=coordsRS;
		this.vIndicesRS=vIndicesRS;
		
		this.backedByFile=true;
		this.inMemory=false;
		
		this.dimensionality=this.bounds.dim();
	
		this.numAttributes=dataRS.size();
	}




	
	public boolean inMemory(){
	
		return inMemory;
	}
	

	//public abstract int writeCells(DataSink sink, int startID);
	
	
	public abstract int writeCells(String dataFileName);

}
