//
//  LinearTriangleCellApproximator.java
//  Unstructured
//
//  Created by Philip Rhodes on Mon Sep 23 2002.
//  Copyright (c) 2002 University of New Hampshire. All rights reserved.
//
// ------------------- Edit history since 01/10/05 --------------------------
//
// 01/10/05 rdb: Now return a Datum that is of the same class as Datums in Cell
//
// --------------------------------------------------------------------------


package edu.unh.sdb.lattice;

import edu.unh.sdb.common.*;

public class LinearTriangleCellApproximator extends UnstructuredApproximator {

    public LinearTriangleCellApproximator(){
    
    }
    
    public Datum approximate( Cell c, Point p ){
    
        Datum[] data=c.getData();
        Point [] points=c.getVertexCoords();
        float [] weights=new float[3];
        float totalDistance=0;
        int i,j,length;
        
        for(i=0;i<3;i++){
            weights[i]=p.distance(points[i]);
            totalDistance+=weights[i];
        }
        
        for(i=0;i<3;i++){
            weights[i]=(1-weights[i]/totalDistance);
        }

//        for(i=0;i<3;i++){
//            weights[i]=(totalDistance-weights[i])/totalDistance;
//        }



        length=data[0].size();
        float newValues[]=new float[length];
        
        
        for(i=0;i<3;i++){ 
            for(j=0;j<length;j++){
                newValues[j]+=data[i].getFloat(j)*weights[i]/2;
            }
        }
         
        //rdb return new FloatDatum(newValues);
        Datum retDatum = (Datum) data[0].clone();
        retDatum.setFloats( newValues );
        return retDatum;
    }
    
    public Datum approximate(Cell c, Point p, RecordSpec s){
        
        return this.approximate(c,p).subset(s);
    }
    
    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }

    
    
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){
    
        return new String(indent+"LinearTriangleCellApproximator:");
    }


}
