//
//  PartitionedFileArrayCellGroup.java
//  Unstructured
//
//  Created by Philip Rhodes on Sat Aug 03 2002.
//  Copyright (c) 2001 University of New Hampshire. All rights reserved.
//------------------- Edit history --------------------------------------
// 10/21/05 rdb: removed unused variables
//-----------------------------------------------------------------------


package edu.unh.sdb.lattice;

import edu.unh.sdb.common.*;
import edu.unh.sdb.datasource.*;
//import java.io.*;

/** This is an array implementation of the CellGroup Class. */
public class PartitionedFileArrayCellGroup extends FileArrayCellGroup {
	
	protected InCoreArrayCellGroupGrid ownedCellGrid;
	protected InCoreArrayCellGroupGrid borrowedCellGrid;
	protected String baseFileName;
	
	protected FDLDescriptor ownedCellGridFDLD;
	protected FDLDescriptor borrowedCellGridFDLD;

    public PartitionedFileArrayCellGroup(GBounds bounds, String vIndicesFDLName,  RecordSpec vIndicesRS, String pointInfoFDLName, RecordSpec pointRS, RecordSpec dataRS){
    
		super(bounds, vIndicesFDLName, vIndicesRS, pointInfoFDLName, pointRS,  dataRS);
		
		this.baseFileName=pointInfoFDLName.replaceAll(".data.xfdl","");
		
		//rdb this.ownedCellGridFDLD=DataSource.createFDLDescriptor(this.baseFileName+".owned.subgrid.xfdl");
		//rdb this.borrowedCellGridFDLD=DataSource.createFDLDescriptor(this.baseFileName+".borrowed.subgrid.xfdl");
		this.ownedCellGridFDLD = FDLDescriptor.create( this.baseFileName+".owned.subgrid.xfdl");
		this.borrowedCellGridFDLD = FDLDescriptor.create( this.baseFileName+".borrowed.subgrid.xfdl");
		
    }

    public Cell findEnclosingCell(Point p){
   
   
		//return super.findEnclosingCell(p);
   		
		if(backedByFile==true && inMemory==false){
		
			readCells();
		}

		TriangleCell cell = (TriangleCell) this.ownedCellGrid.findEnclosingCell(p);
		
		if( cell == null){
		
			return this.borrowedCellGrid.findEnclosingCell(p);

		} else {
		
			return cell;
		}
    
    }
    
	
	public int readCells(){
	
		super.readCells();
		
		//ISBounds topoBounds= new ISBounds(new IntegerIndexSpaceID(4,4));
		//Partitioning subGridPartitioning=new RegularPartitioning(topoBounds, this.bounds);
		
		this.ownedCellGrid=new InCoreArrayCellGroupGrid(this.ownedCellGridFDLD, this.bounds, null, this.ownedVIndices, this.points, this.data, numAttributes);
		this.borrowedCellGrid=new InCoreArrayCellGroupGrid(this.borrowedCellGridFDLD, this.bounds, null, this.borrowedVIndices, this.points, this.data, numAttributes);
		

		return this.numCells;
	}
	
	
	/** Destroy references to cell data. */
	public void empty(){
	
		super.empty();
		
		this.ownedCellGrid=null;
		this.borrowedCellGrid=null;
	}
	
	
    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }    
    
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){
 
	/*   
        String indent2=indent+Globals.toStringIndent;    
        int i,numCells=this.cells.size();
        StringBuffer result=new StringBuffer(indent+"{ PartitionedFileArrayCellGroup: contains ");

        result.append(numCells);
        result.append(" triangles. bounds=");
        result.append(this.bounds);
        result.append("\n");
        
        for(i=0;i<numCells;i++){
            result.append(((Cell) this.cells.get(i)).toString(indent2));
            result.append("\n");
        }
        
        result.append(indent+"}");
        
        return new String(result);
	*/
		return null;
    }
    
}
