//
//  PlanarTriangleCellApproximator.java
//  Unstructured
//
//  Created by Philip Rhodes on Tue Apr 22 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
//
//------------------- Edit history --------------------------------------
// 10/21/05 rdb: removed unused variables
// 01/03/05 rdb Changed new FloatDatum( float ) to Datum.create( float ).
//
//--------------------------------------------------------------------------

package edu.unh.sdb.lattice;

import edu.unh.sdb.common.*;

public class PlanarTriangleCellApproximator extends UnstructuredApproximator {

    public PlanarTriangleCellApproximator(){
    
    }
    
    public Datum approximate(Cell c, Point p){
    
        Datum[] data=c.getData();
        Point [] points=c.getVertexCoords();        
		
		float[] Pa=points[0].getCoords();
		float[] Pb=points[1].getCoords();
		float[] Pc=points[2].getCoords();
		
		float[] s=new float[3];
		float[] t=new float[3];
		
		
		for ( int i=0; i<2; i++){
		
			s[i] = Pc[i] - Pa[i];
			t[i] = Pb[i] - Pa[i];
		}
		
		s[2]=data[2].getFloat(0) - data[0].getFloat(0);
		t[2]=data[1].getFloat(0) - data[0].getFloat(0);

		float A = s[1]*t[2] - s[2]*t[1];
		float B = s[2]*t[0] - s[0]*t[2];
		float C = s[0]*t[1] - s[1]*t[0];
		float D = -(A*Pa[0] + B*Pa[1] + C*data[0].getFloat(0));
		
		float z= -(A*p.getCoord(0) + B*p.getCoord(1) + D)/C;


		//rdb return new FloatDatum(z);
		return Datum.create( z );
		//return new Datum(11.0f);
    }
    
    public Datum approximate(Cell c, Point p, RecordSpec s){
        
        return this.approximate(c,p).subset(s);
    }
    
    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }

    
    
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){
    
        return new String(indent+"PlanarTriangleCellApproximator:");
    }


}
