 //
//  SplitUnstructuredTopology.java
//  Unstructured
//
//  Created by Philip Rhodes on Tue Sep 02 2003.
//  Copyright (c) 2003 University of New Hampshire. All rights reserved.
//

package edu.unh.sdb.lattice; 

import edu.unh.sdb.common.*;


public class SplitUnstructuredTopology extends UnstructuredTopology{
	
	public SplitUnstructuredTopology(String pointInfoFDLFileName, String vIndicesFDLFileName, UnstructuredGeometry geometry, int dimensionality){
	
		super(pointInfoFDLFileName, vIndicesFDLFileName, geometry, dimensionality);


		RecordSpec vIndicesRS=new RecordSpec(new int[] {0,1,2});
		RecordSpec coordsRS=new RecordSpec(new int[] {0,1});
		RecordSpec dataRS=new RecordSpec(new int[] {2});

	
		this.groupGrid=new PartitionedSplitCellGroupGrid(	this.partitioning, 
												null, 
												basePointInfoFileName(pointInfoFDLFileName), 
												baseVIndicesFileName(pointInfoFDLFileName),
												vIndicesRS,
												coordsRS,
												dataRS
											);
	
	}
	
	
	

}
