/* 
	Topology.java
	Copyright 2000 University of New Hampshire
	Durham, NH 03824
*/

package edu.unh.sdb.lattice; 

import edu.unh.sdb.datasource.*;
import edu.unh.sdb.common.*;

/**
 */


public abstract class Topology{

    protected int dimensionality;


    protected Topology(){
    
    }
    
    /** 
    */
    public Topology(int dimensionality){
        
        this.dimensionality=dimensionality;
        
    }

    
	/** Return the dimensionality of this topology.*/
	public int dim(){
	
		return this.dimensionality;
	}

    
    public abstract void activate();    
    
    public abstract Cell findEnclosingCell(IndexSpaceID partitionID,Point p);


	/** return a datum corresponding to the IndexSpaceID argument. */
	public abstract Datum datum(IndexSpaceID id);
	
	/** Return a bounds for the Topology. This may be 1D for unstructured Topologies. */
	public abstract ISBounds getBounds();
													
	/** Return a RecordDescriptor for datums returned by this topology.*/														
	public abstract RecordDescriptor getRecordDescriptor();
	
																																											
    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }    
    
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){
        
        StringBuffer result=new StringBuffer(indent+"dimensionality="+this.dimensionality);
        
        return new String(result);
    }
    
    
}




