//
//  UnstructuredGeometry.java
//  Unstructured
//
//  Created by Philip Rhodes on Mon Aug 12 2002.
//  Copyright (c) 2001 University Of New Hampshire. All rights reserved.
//

package edu.unh.sdb.lattice;


import edu.unh.sdb.datasource.*; 
import edu.unh.sdb.common.*;

public class UnstructuredGeometry extends Geometry {

    protected ISBounds topoBounds;

    public UnstructuredGeometry(ISBounds topoBounds, GBounds bounds){
    
        super(bounds, new RegularPartitioning(topoBounds, bounds), true);
        
        this.topoBounds=(ISBounds) topoBounds.clone();        

     
    }
     
    public UnstructuredGeometry(ISBounds topoBounds, GBounds bounds, AxisOrdering ordering){
        
        super(bounds, new RegularPartitioning(topoBounds, bounds), true);
        
        this.topoBounds=(ISBounds) topoBounds.clone();     
    }

    /** Return a String representing the object. */
    public String toString(){
        
        return this.toString("");
    }    
    
    /** Return a String representing the object indented by the argument string. */
    public String toString(String indent){
    
        StringBuffer result=new StringBuffer(indent+"{ Unstructured Geometry:\n");
        String indent2=indent+Globals.toStringIndent;
        
        result.append(super.toString(indent2));
        
        result.append(indent+"}");
        
        return new String(result);
    }
}
