#ifndef WIN32
#include <arpa/inet.h>
#endif
#include <fstream>
#include <iostream>
#include <cstdlib>
#include <udt.h>
#include <jni.h>
#include "edu_unh_sdb_datasource_RemoteUDTClient.h"

using namespace std;
extern "C" {
	
JNIEXPORT jint JNICALL Java_edu_unh_sdb_datasource_RemoteUDTClient_NativeReceiveData
  (JNIEnv* env, jclass cls, jbyteArray jarr, jstring servIP, jint port, jint size)
{
    const char *ip;
    ip = env->GetStringUTFChars(servIP, NULL);
    if (ip == NULL) {
        return 0; /* OutOfMemoryError already thrown */
    }
    printf("In native method, %s", ip); 

   UDTSOCKET fhandle = UDT::socket(AF_INET, SOCK_STREAM, 0);
   sockaddr_in serv_addr;
   serv_addr.sin_family = AF_INET;
   serv_addr.sin_port = htons(short(port));
#ifndef WIN32
   if (inet_pton(AF_INET, ip, &serv_addr.sin_addr) <= 0)
#else
   if (INADDR_NONE == (serv_addr.sin_addr.s_addr = inet_addr(ip)))
#endif
   {
      cout << "incorrect network address.\n";
      return 0;
   }
   memset(&(serv_addr.sin_zero), '\0', 8);

   if (UDT::ERROR == UDT::connect(fhandle, (sockaddr*)&serv_addr, sizeof(serv_addr)))
   {
      cout << "connect: " << UDT::getlasterror().getErrorMessage() << endl;
      return 0;
   }

   // get size information
   int datasize;

   if (UDT::ERROR == UDT::recv(fhandle, (char*)&datasize, sizeof(int), 0))
   {
      cout << "recv: " << UDT::getlasterror().getErrorMessage() << endl;
      return 0;
   }
   cout << "Planned recv file size: " << datasize << endl;
   	
	 int recvsize;
	 
	 //char buf[datasize]; //can not just use a char pointer or a segment fault will be generated
   jbyte *cppPtr = env->GetByteArrayElements(jarr, 0); //not (env, buf)
   if(cppPtr == NULL){
    	return 0; /* Exception occurred */
   }
   char* buf = (char*)(&(*cppPtr));
   //char* buf;
   //buf = new char[datasize];
	 int handle;
   // receive the stream
   //if (UDT::ERROR == (recvsize = UDT::recv(fhandle, buf, datasize, 0, &handle)))
   if (UDT::ERROR == (recvsize = UDT::recv(fhandle, buf, size, 0, &handle)))
   {
      cout << "recvfile: " << UDT::getlasterror().getErrorMessage() << endl;
      return 0;
   }
	 
	 cout << "Actual recv file size: " << recvsize << endl;

	 
   env->ReleaseByteArrayElements(jarr, cppPtr, 0);
   env->ReleaseStringUTFChars(servIP, ip);
   UDT::close(fhandle);
	 cout << "Done!!!! "<< endl;
   return 0;
}

};
